unit MainWin;
interface
uses
  Windows, Messages, {SysUtils,} Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;
type
  TMainFrm = class(TForm)
    DirListBox: TListBox;
    FileListBox: TListBox;
    Panel1: TPanel;
    DirLabel: TLabel;
    ComboBox: TComboBox;
    Label1: TLabel;
    Splitter1: TSplitter;
    procedure FormShow(Sender: TObject);
    procedure DirListBoxDblClick(Sender: TObject);
    procedure FileListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure DirListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ComboBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ComboBoxChange(Sender: TObject);
  private
  public
  end;
var
  MainFrm: TMainFrm;
implementation
uses ShellApi;
{$R *.DFM}
var
  S:string;
  Bm:TBitMap;
procedure MySearch(S:string);
var
  HF:THandle;
  WF:_WIN32_FIND_DATA;
  NewS:string;
begin
  MainFrm.DirListBox.Items.Clear;
  MainFrm.FileListBox.Items.Clear;
  MainFrm.DirLabel.Caption:=S;
  S:=S+'\*.*';
  HF:=FindFirstFile(PChar(S),WF);
  if HF<>INVALID_HANDLE_VALUE then
  repeat
    NewS:=WF.cFileName;
    if (WF.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY)<>0 then
    begin
      if NewS<>'.' then MainFrm.DirListBox.Items.Add(NewS);
    end
    else MainFrm.FileListBox.Items.Add(NewS);
  until not FindNextFile(HF,WF);
  FindClose(HF);
end;

procedure TMainFrm.FormShow(Sender: TObject);
var
  DriveS:array[0..255]of char;
  P:PChar;
  i:byte;
begin
  ZeroMemory(@DriveS[0],256);
  GetLogicalDriveStrings(255,DriveS);
  i:=0;

  Bm:=TBitmap.Create;
  Bm.LoadFromResourceName(hInstance,'UPFOLDER');
  Bm.Transparent:=true;

  ComboBox.Items.Clear;


  while true do
  begin
    P:=DriveS+i;
    ComboBox.Items.Add(P);
    while DriveS[i]<>#0 do inc(i);
    if (DriveS[i]=#0)and(DriveS[i+1]=#0) then break
    else inc(i);
  end;

  S:='c:';
  MySearch(S);
end;
//-----     
function MyExtrFilePath(const S:string):string;
var
  i:integer;
begin
  i:=Length(S);
  Result:='';
  if (S[i]<>'\')and(S[i]<>':') then
    repeat
      dec(i);
      if i=0 then exit;
    until (S[i]='\')or(S[i]=':');
  Result:=Copy(S,1,i-1);
end;
procedure TMainFrm.DirListBoxDblClick(Sender: TObject);
var
  NewDir:string;
begin
  if DirListBox.ItemIndex=-1 then exit;
  NewDir:=DirListBox.Items.Strings[DirListBox.ItemIndex];
  if NewDir<>'..' then S:=S+'\'+NewDir
  else S:=MyExtrFilePath(S);
  MySearch(S);
end;
procedure TMainFrm.FileListBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  dy:integer;
  FInf:_SHFILEINFO;
begin
  with FileListBox,FileListBox.Canvas do
  begin
    FillRect(Rect);

    SHGetFileInfo(PChar(S+'\'+Items[Index]),
                  0,
                  FInf,
                  SizeOf(_SHFILEINFO),
                  SHGFI_ICON or SHGFI_SMALLICON);

    if FInf.hIcon<>0 then
      DrawIconEx(Handle,Rect.Left+1,Rect.Top+1,FInf.hIcon,
                 16,16,0,0,DI_NORMAL);

    dy:=(ItemHeight-TextHeight(Items[Index])) div 2;
    TextOut(Rect.Left+20,Rect.Top+dy,Items[Index]);
  end;
end;
procedure TMainFrm.DirListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  dy:integer;
  FInf:_SHFILEINFO;
begin
  with DirListBox,DirListBox.Canvas do
  begin
    FillRect(Rect);
    if Items[Index]='..' then
    begin
      dy:=(ItemHeight-Bm.Height) div 2;
      Draw(Rect.Left+20,Rect.Top+dy,Bm);
      exit;
    end;
    SHGetFileInfo(PChar(S+'\'+Items[Index]),
                  0,
                  FInf,
                  SizeOf(_SHFILEINFO),
                  SHGFI_ICON or SHGFI_SMALLICON);

    if FInf.hIcon<>0 then
      DrawIconEx(Handle,Rect.Left+1,Rect.Top+1,FInf.hIcon,
                 16,16,0,0,DI_NORMAL);

    dy:=(ItemHeight-TextHeight(Items[Index])) div 2;
    TextOut(Rect.Left+20,Rect.Top+dy,Items[Index]);
  end;
end;
procedure TMainFrm.ComboBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  dy:integer;
  FInf:_SHFILEINFO;
begin
  with ComboBox,ComboBox.Canvas do
  begin
    FillRect(Rect);
    SHGetFileInfo(PChar(Items[Index]),
                  0,
                  FInf,
                  SizeOf(_SHFILEINFO),
                  SHGFI_ICON or SHGFI_SMALLICON);

    if FInf.hIcon<>0 then
      DrawIconEx(Handle,Rect.Left+1,Rect.Top+1,FInf.hIcon,
                 16,16,0,0,DI_NORMAL);

    dy:=(ItemHeight-TextHeight(Items[Index])) div 2;
    TextOut(Rect.Left+20,Rect.Top+dy,Items[Index]);
  end;
end;
procedure TMainFrm.ComboBoxChange(Sender: TObject);
begin
  if ComboBox.ItemIndex=-1 then exit;
  S:=ComboBox.Items[ComboBox.ItemIndex];
  Delete(S,Length(S),1);
  MySearch(S);
end;
end.
